/*
//@line 38 "/builddir/build/BUILD/spicebird-0.7.1/mozilla/collab/im/components/src/csIMContact.js"
*/

/***********************************************************
* constants
***********************************************************/

const csIIMContact = Components.interfaces.csIIMContact;
const nsISupports = Components.interfaces.nsISupports;

// UUID uniquely identifying our component
const CLASS_ID = Components.ID("{2b3e92ae-77b6-4151-9dba-acb5add31b79}");

// description
const CLASS_NAME = "Component that contains details of a contact";

// textual unique identifier
const CONTRACT_ID = "@synovel.com/collab/im/imcontact;1";

/***********************************************************
* class definition
***********************************************************/

// Class constructor
function csIMContact() {
};

// class definition
csIMContact.prototype = {

    mAccount: "",
    mConnectionID: "",
    mId: "",
    mAlias: "",
    mStatus: "",
    mStatusMessage: "",

    get account() { return this.mAccount; },
    set account(aValue) { this.mAccount = aValue; },

    get id() { return this.mId; },
    set id(aValue) { this.mId = aValue; },

    get alias() { return this.mAlias; },
    set alias(aValue) { this.mAlias = aValue; },

    get status() { return this.mStatus; },
    set status(aValue) { this.mStatus = aValue; },

    get statusMessage() { return this.mStatusMessage; },
    set statusMessage(aValue) { this.mStatusMessage = aValue; },

    get connectionID() { return this.mConnectionID; },
    set connectionID(aValue) { this.mConnectionID = aValue; },

    QueryInterface: function(aIID) {
        if (!aIID.equals(csIIMContact) &&    
            !aIID.equals(nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    }
};

/***********************************************************
* class factory
***********************************************************/

var csIMContactFactory = {
    createInstance: function (aOuter, aIID) {
        if (aOuter != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;
        return (new csIMContact()).QueryInterface(aIID);
    }
};

/***********************************************************
* module definition (xpcom registration)
***********************************************************/
var csIMContactModule = {
    registerSelf: function(aCompMgr, aFileSpec, aLocation, aType) {
        aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
        aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, 
                                         CONTRACT_ID, aFileSpec,
                                         aLocation, aType);
    },

    unregisterSelf: function(aCompMgr, aLocation, aType) {
        aCompMgr = aCompMgr.
                   QueryInterface(Components.interfaces.nsIComponentRegistrar);
        aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);        
    },
  
    getClassObject: function(aCompMgr, aCID, aIID) {
        if (!aIID.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

        if (aCID.equals(CLASS_ID))
            return csIMContactFactory;
        
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    canUnload: function(aCompMgr) { return true; }
};

/***********************************************************
* module initialization
*
* When the application registers the component, this function
* is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return csIMContactModule; }

